import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import _toConsumableArray from "@babel/runtime/helpers/esm/toConsumableArray";
export var getEnclosingBox = function getEnclosingBox(region) {
  switch (region.type) {
    case "polygon":
      {
        var box = {
          x: Math.min.apply(Math, _toConsumableArray(region.points.map(function (_ref) {
            var _ref2 = _slicedToArray(_ref, 2),
                x = _ref2[0],
                y = _ref2[1];

            return x;
          }))),
          y: Math.min.apply(Math, _toConsumableArray(region.points.map(function (_ref3) {
            var _ref4 = _slicedToArray(_ref3, 2),
                x = _ref4[0],
                y = _ref4[1];

            return y;
          }))),
          w: 0,
          h: 0
        };
        box.w = Math.max.apply(Math, _toConsumableArray(region.points.map(function (_ref5) {
          var _ref6 = _slicedToArray(_ref5, 2),
              x = _ref6[0],
              y = _ref6[1];

          return x;
        }))) - box.x;
        box.h = Math.max.apply(Math, _toConsumableArray(region.points.map(function (_ref7) {
          var _ref8 = _slicedToArray(_ref7, 2),
              x = _ref8[0],
              y = _ref8[1];

          return y;
        }))) - box.y;
        return box;
      }

    case "polyline":
      {
        var _box = {
          x: Math.min.apply(Math, _toConsumableArray(region.points.map(function (_ref9) {
            var _ref10 = _slicedToArray(_ref9, 2),
                x = _ref10[0],
                y = _ref10[1];

            return x;
          }))),
          y: Math.min.apply(Math, _toConsumableArray(region.points.map(function (_ref11) {
            var _ref12 = _slicedToArray(_ref11, 2),
                x = _ref12[0],
                y = _ref12[1];

            return y;
          }))),
          w: 0,
          h: 0
        };
        _box.w = Math.max.apply(Math, _toConsumableArray(region.points.map(function (_ref13) {
          var _ref14 = _slicedToArray(_ref13, 2),
              x = _ref14[0],
              y = _ref14[1];

          return x;
        }))) - _box.x;
        _box.h = Math.max.apply(Math, _toConsumableArray(region.points.map(function (_ref15) {
          var _ref16 = _slicedToArray(_ref15, 2),
              x = _ref16[0],
              y = _ref16[1];

          return y;
        }))) - _box.y;
        return _box;
      }

    case "polyline-bs":
      {
        var _box2 = {
          x: Math.min.apply(Math, _toConsumableArray(region.points.map(function (_ref17) {
            var _ref18 = _slicedToArray(_ref17, 2),
                x = _ref18[0],
                y = _ref18[1];

            return x;
          }))),
          y: Math.min.apply(Math, _toConsumableArray(region.points.map(function (_ref19) {
            var _ref20 = _slicedToArray(_ref19, 2),
                x = _ref20[0],
                y = _ref20[1];

            return y;
          }))),
          w: 0,
          h: 0
        };
        _box2.w = Math.max.apply(Math, _toConsumableArray(region.points.map(function (_ref21) {
          var _ref22 = _slicedToArray(_ref21, 2),
              x = _ref22[0],
              y = _ref22[1];

          return x;
        }))) - _box2.x;
        _box2.h = Math.max.apply(Math, _toConsumableArray(region.points.map(function (_ref23) {
          var _ref24 = _slicedToArray(_ref23, 2),
              x = _ref24[0],
              y = _ref24[1];

          return y;
        }))) - _box2.y;
        return _box2;
      }

    case "keypoints":
      {
        var minX = Math.min.apply(Math, _toConsumableArray(Object.values(region.points).map(function (_ref25) {
          var x = _ref25.x,
              y = _ref25.y;
          return x;
        })));
        var minY = Math.min.apply(Math, _toConsumableArray(Object.values(region.points).map(function (_ref26) {
          var x = _ref26.x,
              y = _ref26.y;
          return y;
        })));
        var maxX = Math.max.apply(Math, _toConsumableArray(Object.values(region.points).map(function (_ref27) {
          var x = _ref27.x,
              y = _ref27.y;
          return x;
        })));
        var maxY = Math.max.apply(Math, _toConsumableArray(Object.values(region.points).map(function (_ref28) {
          var x = _ref28.x,
              y = _ref28.y;
          return y;
        })));
        return {
          x: minX,
          y: minY,
          w: maxX - minX,
          h: maxY - minY
        };
      }

    case "expanding-line":
      {
        var _box3 = {
          x: Math.min.apply(Math, _toConsumableArray(region.points.map(function (_ref29) {
            var x = _ref29.x,
                y = _ref29.y;
            return x;
          }))),
          y: Math.min.apply(Math, _toConsumableArray(region.points.map(function (_ref30) {
            var x = _ref30.x,
                y = _ref30.y;
            return y;
          }))),
          w: 0,
          h: 0
        };
        _box3.w = Math.max.apply(Math, _toConsumableArray(region.points.map(function (_ref31) {
          var x = _ref31.x,
              y = _ref31.y;
          return x;
        }))) - _box3.x;
        _box3.h = Math.max.apply(Math, _toConsumableArray(region.points.map(function (_ref32) {
          var x = _ref32.x,
              y = _ref32.y;
          return y;
        }))) - _box3.y;
        return _box3;
      }

    case "line":
      {
        return {
          x: region.x1,
          y: region.y1,
          w: 0,
          h: 0
        };
      }

    case "box":
      {
        return {
          x: region.x,
          y: region.y,
          w: region.w,
          h: region.h
        };
      }

    case "point":
      {
        return {
          x: region.x,
          y: region.y,
          w: 0,
          h: 0
        };
      }

    case "ai-point":
      {
        return {
          x: region.x,
          y: region.y,
          w: 0,
          h: 0
        };
      }

    case "ai-rm-point":
      {
        return {
          x: region.x,
          y: region.y,
          w: 0,
          h: 0
        };
      }

    default:
      {
        return {
          x: 0,
          y: 0,
          w: 0,
          h: 0
        };
      }
  } // eslint-disable-next-line


  throw new Error("unknown region");
};
export var moveRegion = function moveRegion(region, x, y) {
  // eslint-disable-next-line
  switch (region.type) {
    case "point":
      {
        return _objectSpread({}, region, {
          x: x,
          y: y
        });
      }

    case "box":
      {
        return _objectSpread({}, region, {
          x: x - region.w / 2,
          y: y - region.h / 2
        });
      }
  }

  return region;
};